import { Observable, Observer, Subject, Subscription, Unsubscribable } from 'rxjs';
import { AdapterInterface, GeneralEvent, MessageTransmissionInterface, TransmissionConfig, TransmissionProfile, TransmissionRole } from '../interface/interface'
import { v4 as uuidv4 } from 'uuid'
export class MessageTransmissionBase<T> implements MessageTransmissionInterface<T> {
    protected transmissionProfile!: TransmissionProfile
    protected adapters: AdapterInterface<any>[] = []

    constructor(profile: TransmissionConfig, event: Observable<GeneralEvent<T>>) {
        // logic here
    }

    public getTransmissionProfile(type?: `config` | `id` | `role`): TransmissionProfile | string | TransmissionConfig | undefined {
        return type ? this.transmissionProfile[type] : this.transmissionProfile;
    }

    public subscribe(observer: Observer<T> | Observable<T>): Unsubscribable | null {
        throw new Error('Method not implemented.');
    }

    protected setTransmissionProfile(role: TransmissionRole, config: TransmissionConfig): void {
        this.transmissionProfile = {} as TransmissionProfile
        this.transmissionProfile.id = uuidv4()
        this.transmissionProfile.config = config
        this.transmissionProfile.role = role
    }
}

