
import { Subject } from 'rxjs';
import { AdapterInterface, GeneralEvent, MessageReceiverInterface, MessageRequestResponseInterface, MessageTransmissionInterface, MessageTransmissionManagerInterface, MessageTransmitterInterface, TransmissionConfig, TransmissionProfile, TransmissionRole } from '../interface/interface';
import { AdapterManager } from '../adapters/adapter.manager';
import ConsoleLogger from '../utils/log.utils';

export class MessageTransmissionManagerBase<T> implements MessageTransmissionManagerInterface<T> {
    protected console!: ConsoleLogger
    protected browserEnv!: boolean
    protected transmissionObjects: MessageTransmissionInterface<T>[] = []
    protected adapterManager!: AdapterManager
    protected globalEvent!: Subject<GeneralEvent<any>>
    protected transmissionEvent!: Subject<GeneralEvent<any>>

    constructor() {
        // logic here
    }

    getTransmissionObject(config: TransmissionConfig, role: TransmissionRole): MessageTransmissionInterface<T> | null {
        throw new Error(`Method not implemented`)
    }

    getTransmitter(config: TransmissionConfig): MessageTransmitterInterface<T> {
        throw new Error(`Method not implemented`)
    }

    getReceiver(config: TransmissionConfig): MessageReceiverInterface<T> {
        throw new Error(`Method not implemented`)
    }

    getRequestResponse(config: TransmissionConfig, transmitterInstance: MessageTransmitterInterface<T>, receiverInstance: MessageReceiverInterface<T>): MessageRequestResponseInterface<T> {
        throw new Error(`Method not implemented`)
    }

}