
import { Observable, Observer, Subject, Subscription, Unsubscribable } from "rxjs"
import { MessageTransmissionReceiver } from "../transmission/msg.transmission.receiver"
import { MessageTransmissionTransmitter } from "../transmission/msg.transmission.transmitter"


export interface ActorInterface<MessageType> {
    subscribe(subscriberInfo: ActorProfile<any>, observer: Observer<ActorMessage<MessageType>>): Unsubscribable
}

export interface ActorProfile<T = any> {
    actorId: string,
    actorName: string,
    dateCreated?: Date,
    data?: T
}

export interface ActorMessage<T = any> {
    actorProfile: ActorProfile,
    payload: T
}
