import { Express } from 'express';
import { filter, Observable, Subject, Subscription, take } from "rxjs";
import { v4 as uuidv4 } from 'uuid'
import config from '../config/config.json';
import { WrappedMessage } from '../utils/message.ordering';
import { error } from 'console';
import axios, { AxiosError } from 'axios';
import ConsoleLogger from '../utils/log.utils';
import { ClientObject, GeneralEvent, TransportMessage, TransportServiceInterface, TransportServiceProfile } from '../interface/interface';

export class HttpTransportService implements TransportServiceInterface {
    private console: ConsoleLogger = new ConsoleLogger(`HttpTransportService`, ['transport'])
    private baseUrl!: string;
    private info!: TransportServiceProfile
    private connectedHttpServer: ConnectedHttpServer[] = [] // to allow the possibility of having to communicate with multiple servers as a client
    private connectedHttpClients: ConnectedHttpClient[] = [] // to keep track of the all the clients that are connected
    transportEvent!: Subject<GeneralEvent<any>>

    constructor(event: Subject<GeneralEvent<any>>) {
        this.info = {
            transportServiceId: uuidv4(),
            transport: 'Http'
        }
        this.baseUrl = config.connection.transmitter
        this.transportEvent = event
    }

    public subscribeForEvent(): Observable<GeneralEvent<any>> {
        throw new Error('Method not implemented.');
    }

    public getInfo(): TransportServiceProfile {
        return this.info
    }

    public emit(message: TransportMessage): void {
        // code here
    }

    public startServer(port: number): void {
        // code here
    }

    public startClient(url: string, receiverProfileInfo?: ConnectedHttpServer | undefined): void {
        // code hereX
    }

}
export interface ConnectedHttpClient extends ClientObject {
    instance: Express
    responseStream: Subject<WrappedMessage>
}

export interface ConnectedHttpServer extends ClientObject {
}